#!/bin/bash
set -e

# local infrastructure script

if [ "$#" -ne 3 ]; then
   echo "usage: preprocess_sources.sh gnat_qualifier gnat_version gnat_date"
   exit 1
fi

gnat_qualifier=$1
gnat_version=$2
gnat_date=$3

# First prune uneeded directories
for d in gcc/ada \
         libgfortran \
         libobjc \
         boehm-gc \
         fastjar \
         libjava;
do
    echo "+ Remove $d"
    rm -rf "$d"
done

# Then update version files so that gcc -v has the expected output
echo "+ Update version"
sed -e "s/DATESTAMP DEVPHASE/DATESTAMP/" gcc/version.c > gcc/version.c.tmp
rm gcc/version.c
mv gcc/version.c.tmp gcc/version.c
echo "for GNAT $gnat_qualifier $gnat_version ($gnat_date)" > gcc/REVISION
exit 0
